%% exampleScript_CIV2801
%
% Este script  um exemplo do uso de funes e de breakpoints para debug.
% Checa se existem intersees entre duas curvas 2D e plota as curvas.
%
%% ------------------------------------------------------------------------
clear      % Limpa variveis do workspace
clc        % Apaga o que houver escrito no prompt
close all  % Deleta quaisquer figuras abertas

% Polinmio (em forma vetorial) da primeira curva
pol_1 = [-1/5, 4, 5];  % p(x) = -x/5 + 4x + 5

% Polinmio (em forma vetorial) da segunda curva
pol_2 = [1, 2];        % p(x) = x + 2

%% ------------------------------------------------------------------------

% Chama funo getPolyIntsect para obter coordenadas das intersees
intersections = getPolyIntsect(pol_1,pol_2);

% Checa se existem intersees
if isempty(intersections)
    thereAreIntsects = false;
else
    thereAreIntsects = true;
end

% Define domnio de plotagem
switch thereAreIntsects
    case true
        x = linspace((-2 + min(intersections(:,1))),...
                     (2 + max(intersections(:,1))),50);
    case false
        x = -5:0.2:5;
end

% Plota curvas
plot(x,polyval(pol_1,x),'color','blue','linewidth',1.1)
hold on
plot(x,polyval(pol_2,x),'color',[0 0.6 0.2],'linewidth',1.1)
hold on
axis equal
grid on

% Plota intersees, se existirem
switch thereAreIntsects
    case true
        scatter(intersections(:,1),intersections(:,2),[],'red','filled');
        txtScale = diff([x(1),x(end)])/25;
        for i = 1:size(intersections,1)
            x = sprintf('x = %.*f',2,intersections(i,1));
            y = sprintf('y = %.*f',2,intersections(i,2));
            text(intersections(i,1)+txtScale,intersections(i,2)+txtScale...
                 ,x,'color','black')
            text(intersections(i,1)+txtScale,intersections(i,2)-txtScale...
                 ,y,'color','black')
        end
    case false
        msgbox('No existem intersees entre tais curvas')
end

% Limpa variveis do workspace
clear